# 
# Zwiff Product
# 
# Steve Spicklemire
# Silicon Prairie Ventures Inc. (SPVI)
# 
# Disclaimer
# 
#   
#   THIS SOFTWARE IS PROVIDED BY SPVI ``AS IS'' AND ANY EXPRESSED OR
#   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
#   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#   DISCLAIMED.  IN NO EVENT SHALL SPVI OR ITS CONTRIBUTORS BE LIABLE FOR
#   ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
#   GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
#   IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
#   OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
#   ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#   Zwiff requires:
#
#       PythonMethod <http://www.zope.org/Members/4am/PythonMethod >
#       ming         <http://www.opaque.net/ming >
# 

__doc__ = "Zwiff Product"
__version__ = "0.0.3"

import ming
import tempfile
import os
import string

import Products.PythonMethod.Guarded

from Globals import HTMLFile, MessageDialog
from App import Common

manage_addZwiffForm = HTMLFile('addForm',globals())

def manage_addZwiff(self, id, title, params, body, REQUEST=None):
    """Add A Zwiff to a folder .... just like PythonMethod.. 
    """
    it = Zwiff(id, title, params, body)
    self._setObject(id, it)
    return self.manage_main(self, REQUEST)

def handleMovieOutput(movie, RESPONSE):

    fname = tempfile.mktemp()

    movie.save(fname)

    f = open(fname)
    s = f.read()
    f.close()

    RESPONSE.setHeader('Content-type', 'application/x-shockwave-flash')
    
    os.remove(fname)
    
    return s

class Zwiff (Products.PythonMethod.PythonMethod.PythonMethod ):

    meta_type = 'Zwiff'

    def makeFunction(self, compile=0):
        from Products.PythonMethod.Guarded import GuardedBlock, safefuncs, theGuard
        if compile:
            self._checkCBlock(GuardedBlock)
        if self.errors:
            raise "Python Method Error", string.join(self.errors, '\n')
        return self._newfun(compile, {'$guard': theGuard},
              __builtins__=mysafebin, _=safefuncs)


mysafebin = Products.PythonMethod.Guarded.safebin.copy()
mysafebin['zwiff_mod'] = ming                        # add the ming module to the 'safe' methods... 
ming.handleMovieOutput = handleMovieOutput           # add method to output movies to Zope... 
ming.packageDir = Common.package_home( globals() )   # add method to get the package Directory.. 
